Foreman - Bug #1351

New smart variable and match cannot be entered at same time.
11/23/2011 02:39 PM - Steve Traylen
Description

Following on from IRC:
Foreman 0.4.0

If | add a new smart variable to a class and also add a match within the same form
then the smart variable is not saved.

e.g entering a smart variable form of:

name=editfirewall

default value=true

type validate=list

validator constraint=true, false
order=fqgdn, hostgrou, os, domain
match=fgdn=1xfssm4408.example.ch
value=true

results in a log of

Parameters: {"commit"=>"Submit", "authenticity_token"=>"QWtrc1fTFhDiKpkk2AcNMtNBp4eEc/10XGdX2cKTbJk=", "id"=>"firewall",

"puppetclass"=>{"lookup_keys_attributes"=>{"new_lookup_keys"=>{"default_value"=>"", "validator_rule"=>"",

"updated_at"=>"1322075394", "lookup_values_attributes"=>{"new_lookup_values"=>{"value"=>"", "_destroy"=>"", "match"=>""}},
"path"=>"fqdn\r\nhostgroup\r\nos\r\ndomain", "_destroy"=>"", "description"=>"", "validator_type"=>"", "key"=>
"new_1322075399382"=>{"default_value"=>"true", "validator_rule"=>"true,false", "updated_at"=>"1322075394",

"lookup_values_attributes"=>{"new_1322075455358"=>{"value"=>"false", "_destroy"=>"", "match"=>"fqdn=Ixfssm4408.example.ch"},

"new_lookup_values"=>{"value"=>"", "_destroy"=>"", "match"=>""}}, "path"=>"fqdn\r\nhostgroup\r\nos\r\ndomain", "_destroy"=>"",

"description"=>"Use puppet firewall rules.", "validator_type"=>"list", "key"=>"editfirewall"}}, "name"=>"firewall",
||environment_idsll=>["6ll, llll, ll10ll’ Illl, "9", ll||’ ll14ll, llll], llhostgroup_ids||=>[llll’ llll, IIII’ ||ll, IIII’ ||ll, llll’ Illl, llll’ Illl, llll]}}

but the variable is not saved.
Workaround given on IRC.

Add the smart variable first with no match conditions and then add the match conditions as separate
form submits.

Associated revisions

Revision 7a2e06bd - 06/06/2012 05:23 AM - Amos Benari

fixes #1351 New smart variable and match cannot be entered at same time.

History

#1 - 01/29/2012 08:32 AM - Ohad Levy

- Target version set to 1.0
#2 - 01/29/2012 08:48 AM - Ohad Levy

- Assignee set to Amos Benari

@Amos, this seems like the template html used to add a new variable is actually inside the form, so the default submit would always include it.
more then that, the error can't be shown, as the whole div is hidden.

| tried to have a look, but it breaks a bit the pills structure, do you mind taking a look?

#3 - 03/19/2012 04:47 PM - Tray Torrance

I'm hitting this at the nightly release | installed last tuesday, as well. Threw me for quite the loop, as they show up as existing under the "Smart
Variables" section of the associated puppet class, but not in the general listing page for "Smart Variables".

-torrancew

#4 - 06/06/2012 06:48 AM - Amos Benari
- Status changed from New to Closed

- % Done changed from 0 to 100

Applied in changeset 7a2e06bdc1247693dea53e0698117652402c4751.
